local B = CBW_Battle

local state_HuggertDodgeRoll = 1
local state_fret = 2
local HuggertDodgeRoll_time = 10
local HuggertDodgeRoll_endlag = 15
local rollspeed = 45
local cooldown = TICRATE*2

local HuggertDodgeRoll = function(mo,doaction)
	local player = mo.player	
	//Safeguard
 	if player.actionstate != state_HuggertDodgeRoll and not(mo.flags&MF_SPECIAL)
 		mo.flags = $&~MF_NOCLIPTHING
 	end
	if not(B.CanDoAction(player))
		player.actionstate = 0
 		mo.flags = $&~MF_NOCLIPTHING
	end
	
	local water = B.WaterFactor(mo)
	local twod = 1
	if twodlevel or mo.flags2&MF2_TWOD
		twod = 2
	end
	
	player.actionrings = 10
	player.actiontext = "Dodge Roll"
	player.actiontime = $+1
	
	//Triggers
	local HuggertDodgeRoll_trigger = doaction == 1
	
	
	//Perform dodge roll
	if HuggertDodgeRoll_trigger
		B.PayRings(player)
		B.ApplyCooldown(player,cooldown)
		player.actionstate = state_HuggertDodgeRoll
		if player.powers[pw_flashing] < HuggertDodgeRoll_time
			player.powers[pw_flashing] = HuggertDodgeRoll_time
		end
		player.starchargeready = false
		player.starcooldown = 2
		player.clouddown = 2
 		mo.flags = $|MF_NOCLIPTHING
		player.actiontime = 0
		//Do effects
		S_StartSound(mo,sfx_zoom)
		for n = 0,3
			local dust = P_SpawnMobjFromMobj(mo,0,0,0,MT_SPINDUST)
			local angle = (180+P_RandomRange(-60,60))*ANG1+mo.angle
			local speed = mo.scale*P_RandomRange(5,10)
			P_InstaThrust(dust,angle,speed)
		end
		
		for i = 0, 12
			local sparkstrail = P_SpawnMobjFromMobj(player.mo, (P_RandomRange(-5,5)*player.mo.scale),(P_RandomRange(-5,5)*player.mo.scale),(P_RandomRange(-5,5)*player.mo.scale), MT_BOXSPARKLE)
			sparkstrail.scale = $*(1/P_RandomRange(1, 3))
			sparkstrail.color = player.mo.color
			sparkstrail.colorized = true
			sparkstrail.momx = P_RandomRange(-2, 2)*player.mo.scale
			sparkstrail.momy = P_RandomRange(-2, 2)*player.mo.scale
			sparkstrail.momz = P_RandomRange(-2, 2)*player.mo.scale
			sparkstrail.destscale = 0
			sparkstrail.scalespeed = player.mo.scale/25
			sparkstrail.fuse = TICRATE/2
			sparkstrail.frame = $|FF_FULLBRIGHT
		end
		for c = 0, 3
			local st = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-20, 20)*player.mo.scale,P_RandomRange(-20, 20)*player.mo.scale,P_RandomRange(-15, 30)*player.mo.scale, MT_HUGGERTSSTARPART)
			st.scale = player.mo.scale*(P_RandomRange(1, 3)/2)
			st.color = ColorOpposite(player.mo.color)
			st.destscale = 0 
			st.scalespeed = FRACUNIT/15
			sparkstrail.momx = P_RandomRange(-6, 6)*player.mo.scale
			sparkstrail.momy = P_RandomRange(-6, 6)*player.mo.scale
			sparkstrail.momz = P_RandomRange(-6, 6)*player.mo.scale
		end
	end
	//Dodge roll state
	if player.actionstate == state_HuggertDodgeRoll
		player.lockaim = true
		player.lockmove = true
		mo.state = S_PLAY_ROLL
		mo.frame = (player.actiontime/2)%4
		P_InstaThrust(mo,mo.angle,rollspeed*mo.scale/twod/water)
		player.mo.flags = $|MF_NOCLIPTHING
		P_SetObjectMomZ(mo,0,false)
		//End dodge roll
		if player.actiontime > HuggertDodgeRoll_time
			mo.momx = $/2
			mo.momy = $/2
 			mo.flags = $&~MF_NOCLIPTHING
			//Do fret
			player.actionstate = state_fret
			player.actiontime = 0
			if not(P_IsObjectOnGround(mo))
				player.pflags = ($|PF_THOKKED)&~(PF_JUMPED|PF_SPINNING)
			else
				S_StartSound(mo,sfx_skid)
			end
		end
	end
	//Fret state
	if player.actionstate == state_fret
		if player.actiontime < HuggertDodgeRoll_endlag //Do animation
			player.lockaim = true
			player.lockmove = true
			mo.state = S_PLAY_FALL
			mo.sprite2 = SPR2_EDGE
			if P_IsObjectOnGround(mo) and player.speed > FRACUNIT*4 and player.actiontime%3 == 0
				P_SpawnMobjFromMobj(mo,0,0,0,MT_DUST)
			end
		else //Return to normal
			player.actionstate = 0
		end
	end
end


local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle 
		then
		ScriptLoaded = true 
		local B = CBW_Battle

		local HuggertDodgeRoll = function(mo,doaction)
			local player = mo.player	
			//Safeguard
			if player.actionstate != state_HuggertDodgeRoll and not(mo.flags&MF_SPECIAL)
				mo.flags = $&~MF_NOCLIPTHING
			end
			if not(B.CanDoAction(player))
				player.actionstate = 0
				mo.flags = $&~MF_NOCLIPTHING
			end
			
			local water = B.WaterFactor(mo)
			local twod = 1
			if twodlevel or mo.flags2&MF2_TWOD
				twod = 2
			end
			
			player.actionrings = 10
			player.actiontext = "Dodge Roll"
			player.actiontime = $+1
			
			//Triggers
			local HuggertDodgeRoll_trigger = doaction == 1
			
			
			//Perform dodge roll
			if HuggertDodgeRoll_trigger
				B.PayRings(player)
				B.ApplyCooldown(player,cooldown)
				player.actionstate = state_HuggertDodgeRoll
				if player.powers[pw_flashing] < HuggertDodgeRoll_time
					player.powers[pw_flashing] = HuggertDodgeRoll_time
				end
				//Get angle
		-- 		local input =
				mo.flags = $|MF_NOCLIPTHING
				player.actiontime = 0
				//Do effects
				S_StartSound(mo,sfx_zoom)
				for n = 0,3
					local dust = P_SpawnMobjFromMobj(mo,0,0,0,MT_SPINDUST)
					local angle = (180+P_RandomRange(-60,60))*ANG1+mo.angle
					local speed = mo.scale*P_RandomRange(5,10)
					P_InstaThrust(dust,angle,speed)
				end
				
				for i = 0, 12
					local sparkstrail = P_SpawnMobjFromMobj(player.mo, (P_RandomRange(-5,5)*player.mo.scale),(P_RandomRange(-5,5)*player.mo.scale),(P_RandomRange(-5,5)*player.mo.scale), MT_BOXSPARKLE)
					sparkstrail.scale = $*(1/P_RandomRange(1, 3))
					sparkstrail.color = player.mo.color
					sparkstrail.colorized = true
					sparkstrail.momx = P_RandomRange(-2, 2)*player.mo.scale
					sparkstrail.momy = P_RandomRange(-2, 2)*player.mo.scale
					sparkstrail.momz = P_RandomRange(-2, 2)*player.mo.scale
					sparkstrail.destscale = 0
					sparkstrail.scalespeed = player.mo.scale/25
					sparkstrail.fuse = TICRATE/2
					sparkstrail.frame = $|FF_FULLBRIGHT
				end
				for c = 0, 3
					local st = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-20, 20)*player.mo.scale,P_RandomRange(-20, 20)*player.mo.scale,P_RandomRange(-15, 30)*player.mo.scale, MT_HUGGERTSSTARPART)
					st.scale = player.mo.scale*(P_RandomRange(1, 3)/2)
					st.color = ColorOpposite(player.mo.color)
					st.destscale = 0 
					st.scalespeed = FRACUNIT/15
					st.momx = P_RandomRange(-6, 6)*player.mo.scale
					st.momy = P_RandomRange(-6, 6)*player.mo.scale
					st.momz = P_RandomRange(-6, 6)*player.mo.scale
				end
			end
			//Dodge roll state
			if player.actionstate == state_HuggertDodgeRoll
				player.lockaim = true
				player.lockmove = true
				mo.state = S_PLAY_ROLL
				mo.frame = (player.actiontime/2)%4
				P_InstaThrust(mo,mo.angle,rollspeed*mo.scale/twod/water)
				player.mo.flags = $|MF_NOCLIPTHING
				P_SetObjectMomZ(mo,0,false)
				//End dodge roll
				if player.actiontime > HuggertDodgeRoll_time
					mo.momx = $/2
					mo.momy = $/2
					mo.flags = $&~MF_NOCLIPTHING
					//Do fret
					player.actionstate = state_fret
					player.actiontime = 0
					if not(P_IsObjectOnGround(mo))
						player.pflags = ($|PF_THOKKED)&~(PF_JUMPED|PF_SPINNING)
					else
						S_StartSound(mo,sfx_skid)
					end
				end
			end
			//Fret state
			if player.actionstate == state_fret
				if player.actiontime < HuggertDodgeRoll_endlag //Do animation
					player.lockaim = true
					player.lockmove = true
					mo.state = S_PLAY_FALL
					mo.sprite2 = SPR2_EDGE
					if P_IsObjectOnGround(mo) and player.speed > FRACUNIT*4 and player.actiontime%3 == 0
						P_SpawnMobjFromMobj(mo,0,0,0,MT_DUST)
					end
				else //Return to normal
					player.actionstate = 0
				end
			end
		end
		
		local ExhaustHuggert = function(player) --fine, i'll nerf it >:(
			if player.hugflytime == nil or P_IsObjectOnGround(player.mo) then player.hugflytime = 4*TICRATE end
			if player.mo.state == S_HUGGERTFLY and player.hugflytime > 0 then player.hugflytime = $-1 end
			
			if player.hugflytime < 2*TICRATE and player.hugflytime % 16 == 0 and player.mo.state == S_HUGGERTFLY
				S_StartSound(player.mo, sfx_s1b6)
				P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FRANKSWET)
			end
			
			if player.hugflytime == 1 or  player.hugflytime == 0
				player.hugjump  = -69
				player.mo.state = S_PLAY_FALL
					
				return true
			end
			return false
		end
		
		CBW_Battle.SkinVars["huggert"] = {
			flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
			weight = 75,
			special = HuggertDodgeRoll,
			guard_frame = 1,
			func_exhaust = ExhaustHuggert,
		}
	end
end)